import random

class Circus:
  # There are:
  # 4 wagons of each colors (until 2 players' stop)
  # 2 wagons of each colors (until 3 players' stop)
  # 2 wagons of each colors (until 4 players' stop)
  # 2 wagons of each colors (until 5 players' stop)
  # NOTE: In the original distribution, the same color never appears twice in a row
  #   We chose to remove this constraint, for the sake of simplicity

  def __init__(self, playersNb):
    wagonsPerColors = 2 * playersNb
    colors = "blue", "green", "black", "red", "yellow"
    remaining = {"blue": wagonsPerColors, "green": wagonsPerColors, "black": wagonsPerColors, "red": wagonsPerColors,\
      "yellow": wagonsPerColors}
    self.wagons = []
    for n in range(0, 5 * wagonsPerColors):
      color = colors[random.randint(0, 4)]
      while remaining[color] == 0:
        color = colors[random.randint(0, 4)]
      self.wagons.append(color)
      remaining[color] = remaining[color] - 1
    self.state = 0 # 0 means Circus is not used in game yet, 1 means next wagon in list is #1, and so on

  def enable(self):
    if self.state > 0:
      print("Circus is already in game.")
      return False
    self.state = 1

  def getNextColor(self):
    return self.wagons[self.state - 1]

  def takeWagon(self):
    if self.state == 0:
      print("Circus is not or no longer in game.")
      return False
    print("Player obtained a " + self.wagons[self.state - 1] + " circus sticker!")
    self.state = self.state + 1
    if self.state > len(self.wagons):
      print("Circus stickers are now depleted.")
      self.state = 0 # effectively disable circus
