import random

class ConcessionCard:
  # Each card contains:
  # 6 cities to connect to the player's concession. There is no need to implement those.
  # 7 gold nuggets, as rewards when the player succefully connects a city to their concession. The player can choose
  # which nugget to earn, and then discovers the associated reward (between 11 and 17 coins).
  # A ConcessionCard is then composed of 7 nuggets, with the rewards randomly distributed.

  def __init__(self):
    availableValues = [11, 12, 13, 14, 15, 16, 17]
    nuggetsNb = len(availableValues) - 1
    self.nuggets = []
    for n in range(0, 7):
      choice = random.randint(0, nuggetsNb - n)
      self.nuggets.append(availableValues[choice])
      availableValues.pop(choice)
    self.taken = set()

  def getRemainingPepites(self):
    return {1, 2, 3, 4, 5, 6, 7} - self.taken

  def takeReward(self, choice):
    if not choice.isdigit():
      print("Please choose a number.")
      return False
    choice = int(choice)
    if choice not in range(1, 8):
      print("This is not a valid number")
      return False
    if choice in self.taken:
      print(str(choice) + " has already been obtained.")
      return False
    self.taken.add(choice)
    print("Congrats! You obtained $" + str(self.nuggets[choice - 1]))

class Player:

  def __init__(self, color):
    self.color = color
    self.concession = ConcessionCard()
